#
# Macros for cmake
#
# Warning: do not remove the -DCMAKE_MODULE_LINKER_FLAGS command as it is required to build kde and qt apps
#

%__cmake %{_bindir}/cmake
%__ctest %{_bindir}/ctest

%_cmake_verbose -DCMAKE_VERBOSE_MAKEFILE:BOOL=ON
%_cmake_debug %{?with_debug:debug}%{?!with_debug:RelWithDebInfo}
%_cmake_module_linker_flags %(echo %ldflags|sed -e 's#-Wl,--no-undefined##')

%cmake \
    %set_build_flags \
    %__cmake %{?_cmake_Wdev:-Wdev}%{?!_cmake_Wdev:-Wno-dev} \\\
        -S %{_vpath_srcdir} \\\
        -B %{_vpath_builddir} \\\
        -DCMAKE_CXX_FLAGS_RELWITHDEBINFO:STRING="-DNDEBUG" \\\
        -DCMAKE_C_FLAGS_RELWITHDEBINFO:STRING="-DNDEBUG" \\\
        -DCMAKE_CXX_FLAGS_RELEASE:STRING="-DNDEBUG" \\\
        -DCMAKE_C_FLAGS_RELEASE:STRING="-DNDEBUG" \\\
        -DCMAKE_INSTALL_DO_STRIP:BOOL=OFF \\\
        -DCMAKE_INSTALL_LIBDIR:PATH=%{_lib} \\\
        -DCMAKE_INSTALL_LIBEXECDIR:PATH=libexec \\\
        -DCMAKE_INSTALL_PREFIX:PATH=%{_prefix} \\\
        -DCMAKE_INSTALL_RUNSTATEDIR:PATH=%{_rundir} \\\
        -DCMAKE_INSTALL_SYSCONFDIR:PATH=%{_sysconfdir} \\\
        -DINCLUDE_INSTALL_DIR:PATH=%{_includedir} \\\
        -DLIB_INSTALL_DIR:PATH=%{_libdir} \\\
        -DSYSCONF_INSTALL_DIR:PATH=%{_sysconfdir} \\\
        -DSHARE_INSTALL_PREFIX:PATH=%{_datadir} \\\
        -DCMAKE_BUILD_TYPE=%{_cmake_debug} \\\
%if "%{?_lib}" == "lib64" \
        -DLIB_SUFFIX=64 \\\
%endif \
        %{?_cmake_verbose} \\\
        %{?_cmake_module_linker_flags:-DCMAKE_MODULE_LINKER_FLAGS="%_cmake_module_linker_flags%{?_cmake_module_linker_flags_extra: %_cmake_module_linker_flags_extra}"} \\\
        -DBUILD_SHARED_LIBS:BOOL=ON \\\
        -DBUILD_STATIC_LIBS:BOOL=OFF

%cmake_build \
    %__cmake --build "%{_vpath_builddir}" %{?_smp_mflags} --verbose

%cmake_install \
    DESTDIR="%{buildroot}" %__cmake --install "%{_vpath_builddir}"

%ctest(:-:h:j:u:v:A:C:D:E:F:H:I:L:M:N:O:Q:R:S:T:U:V:) \
    cd %{_vpath_builddir} \
    %__ctest --output-on-failure --force-new-ctest-process %{?_smp_mflags} %{**} \
    cd ..
